[PATCH] configure: check whether shell is capable of parameter substring processing

Tomi Ollila tomi.ollila at iki.fi
Thu May 3 11:59:58 PDT 2012


'configure' script uses parameter substring extensively. It is Posix shell
feature. Original Bourne shell does not have such features. Some systems
still ships such shells as /bin/sh (for compatibility reasons -- shell
scripts written on those platforms are expected to work on 1990's systems).

Just testing whether parameter substring processing works will make the
shell exit due to syntax error if it is not compatible. Therefore the test
is executed in a subshell -- subshell exits with nonzero value when the
operation in question fails.

As 'if ! ...' does not work in Bourne shell, Short-circuiting construct
'||' is used to print information message and exit when expected.
---
This is now based on last short talk on IRC. Anyone good with words
care to comment on text content ? :)

This patch obsoletes:

id:"1334643263-30207-1-git-send-email-tomi.ollila at iki.fi" , 
id:"1334589199-25894-1-git-send-email-tomi.ollila at iki.fi"
and
id:"1333966665-10469-2-git-send-email-Vladimir.Marek at oracle.com"

 configure |   14 ++++++++++++++
 1 files changed, 14 insertions(+), 0 deletions(-)

diff --git a/configure b/configure
index 71981b7..7a13102 100755
--- a/configure
+++ b/configure
@@ -1,5 +1,19 @@
 #! /bin/sh
 
+# Test whether this shell is capable of parameter substring processing.
+( option='a/b'; : ${option#*/} ) 2>/dev/null || {
+    echo "
+The shell interpreting '$0' is lacking some required features.
+
+To work around this problem you may try to execute:
+
+    ksh $0 $*
+ or
+    bash $0 $*
+"
+    exit 1
+}
+
 # Store original IFS value so it can be changed (and restored) in many places.
 readonly DEFAULT_IFS=$IFS
 
-- 
1.7.8.2



More information about the notmuch mailing list